// Date 16 January 2013
// This software routine will test to see if there is an output fault
// and set the relevant output ports.
// Device: PIC12F629
// Pin Asignments:
// GP0 --> Power Switch Input - Low = Switch Pressed
// GP1 --> Turns the speaker relay on - High = Relay ON
// GP2 --> Turns power relay on - High = Relay ON
// GP3 --> Can only be used as input. Output Fault Sense. Low = Fault on output
// GP4 --> Drives Power LED. Low = LED ON
// GP5 --> Drives Fault LED. Low = LED ON

#include <htc.h>
#include "Define_Amp.h"

bit fPowerOn;							// Bit to indicate if Power is on
bit fOutputFault;						// Bit to indicate if there is a fault on the output
bit fPowerLed;							// Indicate status of power led
bit fFaultLed;							// Indicate status of fault led
bit fSpeakerRelay;						//
bit fPowerOff;

extern void delay_ms(unsigned int);				// Delay routine.

__CONFIG( 0x0144 );								// Int Osc, WDT = off, PUT = on, MCLRE = Internal, BODEN = on, CP = off, CPD = on

void main(void) 
{ 
//OPTION=0b00000001;								// Sets Prescaler to 1/16
TRISIO=0b00001001;								// GP0 & GP3 = Inputs
GPIO = 0;										// Set All outputs low
CMCON = 7;										// Switch off comparators

fPowerOn = 0;									// Set Power On Flag to 0
fOutputFault = 0;								// Set Output fault flag to 0
FaultLed = 1;									// Set Output High
PowerLed = 1;									// Set Output High
fPowerLed = 1;									// Indicate status of power led
fFaultLed = 1;									// Indicate status of fault led
PowerOn = 0;
SpeakerRelay = 0;

while (1)
{ 

if (OutputFault == 1)							//  DC on output
	{
		if (fPowerOn == 1)
			{
	 		fOutputFault = 1;					// Set fault flag
			delay_ms(2);
			FaultLed = 1;
			delay_ms(2);
			FaultLed = 0;	
			SpeakerRelay = 0;
				  if (PowerSwitch == 0)
 					{ 	  
					if (fPowerOn == 1)
						{
		 				fPowerOff = 1;
		 				PowerLed = 1;
		 				FaultLed = 1;
		 				PowerOn = 0;
		 				SpeakerRelay = 0;
		 				fPowerOn = 0;
		 				delay_ms(10);
						fOutputFault = 0;
						}
					}		
			}
	}


if (fOutputFault == 1)	 
 {
	if (fPowerOn == 0)
			{	
			fOutputFault = 1;						// DC on output present
			PowerLed = 1;
	    	FaultLed = 0;
			SpeakerRelay = 0;
			delay_ms (5);
			}
	else
			{
			fOutputFault = 1;					// Set fault flag
			PowerLed = 1;
			delay_ms(2);
			FaultLed = 1;
			delay_ms(2);
			FaultLed = 0;	
			SpeakerRelay = 0;
			}
 }			
 

if (fOutputFault == 0 )
  {
	if (PowerSwitch == 0)
	{ if (fPowerOn == 0)
		{
		 FaultLed = 0;
		 PowerOn=1;
		 delay_ms (20);
		 FaultLed = 1;
		 fPowerOff = 0;
		 PowerLed = 0;
		 SpeakerRelay = 1;
		 fPowerOn = 1;
		 PowerSwitch = 1;
		 fOutputFault = 0;
		}
	}
  if (PowerSwitch == 0)
 	{ 	  
	if (fPowerOn == 1)
		{
		 fPowerOff = 1;
		 PowerLed = 1;
		 FaultLed = 1;
		 PowerOn = 0;
		 SpeakerRelay = 0;
		 fPowerOn = 0;
		 delay_ms(10);
		}
	}
 }

//if (fOutputFault == 1)
//  {
//	delay_ms(1);
//	FaultLed = 1;
//	delay_ms(1);
//	FaultLed = 0;	
//	SpeakerRelay = 0;
//  }
	
 if (PowerSwitch == 0)
 	{ 	  
	if (fPowerOn == 1)
		{
		 fPowerOff = 1;
		 PowerLed = 1;
		 FaultLed = 1;
		 PowerOn = 0;
		 SpeakerRelay = 0;
		 fPowerOn = 0;
		 delay_ms(10);
		 fOutputFault = 0;
		}
	}

  
}
}
